
package jp.ne.so_net.za2.kitade.chat;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.math.*;
import sun.io.*;
import java.net.*;

/**
 * ChatT[ubg{
 * @author			S.Kitade
 * @version			1.1
 * @date			2003.11.22
 * @file			ChatServlet.java
 * 
 *  mail : kitade@za2.so-net.ne.jp
 *  URL  : http://www02.so-net.ne.jp/~kitaz/servlet/
 * 
 */



public class ChatServlet extends HttpServlet implements ChatDefs
{
	/** nhʗpNX */
	class HandleIdentifier {
		/** ŏIANZX */
		Calendar m_calUpdated;
		/** NbL[쐬ꂽ̕ */
		String m_strCreated;

		HandleIdentifier()
		{
			m_calUpdated = null;
			m_strCreated = null;
		}
		HandleIdentifier(Calendar calUpdated, String strCal)
		{
			m_calUpdated = calUpdated;
			m_strCreated = strCal;
		}

		Calendar getCalendarUpdated()
		{
			return m_calUpdated;
		}
		void setCalendarUpdated(Calendar cal)
		{
			m_calUpdated = cal;
		}
		String getCalendarCreatedStr()
		{
			return m_strCreated;
		}
		void setCalendarCreatedStr(String strCal)
		{
			m_strCreated = strCal;
		}
	}

	/** Cookienho */
	private String getHandleStringFromCookie(Cookie cookie)
	{
		String strValueString;
		try {
			// Shift_JIS ̃oCĝ܂܎o
			strValueString = URLDecoder.decode(cookie.getValue(), "8859_1");
		}
		catch( UnsupportedEncodingException ex ){
			System.err.println( ex.toString() );
			return null;
		}
		int nDelimiterIndex = strValueString.indexOf('\r');
		if ( nDelimiterIndex < 0 ) {
			return null;
		}
		return strValueString.substring(nDelimiterIndex + 1);
	}

	/** Cookie̕o */
	private String getCalendarStringFromCookie(Cookie cookie)
	{
		String strValueString;
		try {
			// Shift_JIS ̃oCĝ܂܎o
			strValueString = URLDecoder.decode(cookie.getValue(), "8859_1");
		}
		catch( UnsupportedEncodingException ex ){
			System.err.println( ex.toString() );
			return null;
		}
		int nDelimiterIndex = strValueString.indexOf('\r');
		if ( nDelimiterIndex < 0 ) {
			return null;
		}
		Long lTime = new Long( strValueString.substring(0, nDelimiterIndex) );
		Calendar cal = new GregorianCalendar();
		cal.setTime(new Date(lTime.longValue()));
		return cal.toString();
	}

	/** Cookiepɓƃnhencode */
	private String makeHandleAndTimeStringForCookie(String strName)
	{
		Long lTime = new Long(System.currentTimeMillis());
		StringBuffer strBuffer = new StringBuffer( lTime.toString() );
		strBuffer.append('\r');
		strBuffer.append(strName);
		//System.out.println("makeHandleAndTimeStringForCookie : " + strBuffer.toString());
		try {
			// Shift_JIS ̃oCĝ܂ܕۑ
			return URLEncoder.encode(strBuffer.toString(), "8859_1");
		}
		catch( UnsupportedEncodingException ex ){
			System.err.println( ex.toString() );
			return null;
		}
	}

	/** R}hp[^p */
	protected static final String STR_ACTION = "action";
	/** [U[inhj̃p[^p */
	protected static final String STR_USERNAME = "username";
	/** bZ[Wp[^p */
	protected static final String STR_MESSAGE = "message";
	/** Oinhj̓tH[hc */
	protected static final String STR_ID_NAMEFORM = "nameform";
	/** bZ[W̓tH[hc */
	protected static final String STR_ID_MESSFORM = "messform";
	/** ގtH[hc */
	protected static final String STR_ID_QUITFORM = "quitform";

	protected static final String STR_ACT_ENTER = "login";	// R}hFɓ
	protected static final String STR_ACT_QUIT = "logout";	// R}hFo
	protected static final String STR_ACT_TALKING = "talking";	// R}hFb𑱂

	/** Ot@C̃pXip[^擾j */
	protected static String m_strLogPath;
	/** y[Wɕ\^Cgip[^擾j */
	protected static String m_strTitle;
	/** ^Cg̉̃Rgip[^擾j */
	protected static String m_strComment;
	/** L^őf[^ip[^擾j */
	protected static int m_nMaxDoc;
	/** Fip[^擾j */
	protected static String m_strTextColor;
	/** wiFip[^擾j */
	protected static String m_strBGColor;
	/** NFip[^擾j */
	protected static String m_strLinkColor;
	/** Qƍς݃NFip[^擾j */
	protected static String m_strVLinkColor;
	/** GCAXip[^擾j */
	protected static String m_strAlias;
	/** OAbZ[W̍ő啶ioCgł͂Ȃjip[^擾j */
	protected static int m_nMaxMessLength;
	/** ꍇAގƂ݂Ȃ鎞ԁijip[^擾j */
	protected static int m_nAutoQuit;
	/** \ɗp镶R[hip[^擾j */
	protected static String m_strCharaCode;
	/** NbL[ۑ ip[^擾j */
	protected static int m_nCookieDays;
	/** wi摜 ip[^擾j */
	protected static String m_strBGImage;
	/** HOMẼNAhXip[^擾j */
	protected static String m_strHomeURL;

	/** `bgOIuWFNg */
	protected static ChatLog m_chatLog = null;

	/** ֎~[h`FbNIuWFNg */
	protected static WordChecker m_wordChecker = null;

	/** nhǗpHashtableiHashMapł͂ȂAXbhZ[tHashtablepj */
	protected static Hashtable m_handleTable = null;

	/**  */
	public void init(ServletConfig config)
		throws ServletException
	{
		super.init(config);

		// p[^擾iweb.xmlɏẮj
		m_strCharaCode = config.getInitParameter(DEFS_INIT_PARAM_CHARSET);	// R[hn߂
		if ( !(ChatServlet.isStrFair(m_strCharaCode)) ) {
			m_strCharaCode = DEFS_DEFAULT_CHARSET;
			ChatServlet.debugTrace("DEFS_INIT_PARAM_CHARSET is null?");
		}
		m_strLogPath = config.getInitParameter(DEFS_INIT_PARAM_LOGPATH);
		m_strTitle = ChatServlet.native2uni( config.getInitParameter(DEFS_INIT_PARAM_TITLE) );
		m_strComment = ChatServlet.native2uni( config.getInitParameter(DEFS_INIT_PARAM_COMMENT) );
		m_strTextColor = config.getInitParameter(DEFS_INIT_PARAM_TEXTCOLOR);
		m_strLinkColor = config.getInitParameter(DEFS_INIT_PARAM_LINKCOLOR);
		m_strVLinkColor = config.getInitParameter(DEFS_INIT_PARAM_VLINKCOLOR);
		m_strBGColor = config.getInitParameter(DEFS_INIT_PARAM_BGCOLOR);
		m_strAlias = config.getInitParameter(DEFS_INIT_PARAM_ALIAS);
		m_strHomeURL = config.getInitParameter(DEFS_INIT_PARAM_HOMEURL);
		if ( !(ChatServlet.isStrFair(m_strAlias)) ) {
			m_strAlias = DEFS_DEFAULT_STR_ALIAS;
			ChatServlet.debugTrace("DEFS_INIT_PARAM_ALIAS is null?");
		}
		m_nMaxDoc = ChatServlet.parseIntWithDefaultValue(
			config.getInitParameter(DEFS_INIT_PARAM_MAXDATANUM), DEFS_INIT_PARAM_MAXDATANUM, DEFS_DEFAULT_DATANUM );
		m_nMaxMessLength = ChatServlet.parseIntWithDefaultValue(
			config.getInitParameter(DEFS_INIT_PARAM_MAXMESSLENGTH), DEFS_INIT_PARAM_MAXMESSLENGTH, DEFS_DEFAULT_MAXMESSLENGTH );
		m_nAutoQuit = ChatServlet.parseIntWithDefaultValue(
			config.getInitParameter(DEFS_INIT_PARAM_AUTOQUIT), DEFS_INIT_PARAM_AUTOQUIT, DEFS_DEFAULT_AUTOQUIT );
		m_nCookieDays = ChatServlet.parseIntWithDefaultValue(
			config.getInitParameter(DEFS_INIT_PARAM_COOKIEDAYS), DEFS_INIT_PARAM_COOKIEDAYS, DEFS_DEFAULT_COOKIEDAYS );
		m_strBGImage = config.getInitParameter(DEFS_INIT_PARAM_BGIMAGE);
		if ( !(ChatServlet.isStrFair(m_strBGImage)) ) {
			m_strBGImage = "";
			ChatServlet.debugTrace("DEFS_INIT_PARAM_BGIMAGE is null?");
		}

		if ( !(ChatServlet.isStrFair(m_strBGImage)) ) {
			m_strBGImage = "";
			ChatServlet.debugTrace("DEFS_INIT_PARAM_BGIMAGE is null?");
		}
		if ( !(ChatServlet.isStrFair(m_strTextColor)) ) {
			m_strTextColor = "#000000";
			ChatServlet.debugTrace("DEFS_INIT_PARAM_TEXTCOLOR is null?");
		}
		if ( !(ChatServlet.isStrFair(m_strBGColor)) ) {
			m_strBGColor = "#FFFFFF";
			ChatServlet.debugTrace("DEFS_INIT_PARAM_BGCOLOR is null?");
		}
		if ( !(ChatServlet.isStrFair(m_strLinkColor)) ) {
			m_strLinkColor = "#0000C0";
			ChatServlet.debugTrace("DEFS_INIT_PARAM_LINKCOLOR is null?");
		}
		if ( !(ChatServlet.isStrFair(m_strVLinkColor)) ) {
			m_strVLinkColor = "#000060";
			ChatServlet.debugTrace("DEFS_INIT_PARAM_VLINKCOLOR is null?");
		}
		if ( !(ChatServlet.isStrFair(m_strHomeURL)) ) {
			m_strHomeURL = "./";
			ChatServlet.debugTrace("DEFS_INIT_PARAM_HOMEURL is null?");
		}

		// Of[^
		try {
			m_chatLog = new ChatLog(m_strLogPath, m_nMaxDoc, m_nMaxMessLength, m_strCharaCode);
			if ( m_chatLog.logOpen() == false ) {
				// ŏ̋Nł̓t@CƂ낤O͓Ȃ
				ChatServlet.debugTrace("Can't open LogFile !");
			}
		}
		catch(Exception e){
			throw(new  ServletException(e.getMessage()));
		}

		// ֎~[h`FbNf[^ingword.txtLOGPATHɒuĂKvAj
		try {
			m_wordChecker = new WordChecker(m_strLogPath, m_strCharaCode);
			if ( m_wordChecker.loadNGWord() == false ) {
				// ŏ̋Nł̓t@CƂ낤O͓Ȃ
				ChatServlet.debugTrace("Can't open NGWord File !");
				// G[bZ[WOɉ
				m_chatLog.logWrite("(SYSTEM--)", "Can't open WordCheck File !");
			}
		}
		catch(Exception e){
			throw(new  ServletException(e.getMessage()));
		}

		// NbZ[WOɉ
		m_chatLog.logWrite("(SYSTEM--)", "ChatServlet started.");

		// nhiOjۑpHashtable
		m_handleTable = new Hashtable();
	}

	/** T[ubgȈ */
	public void destroy() {
		if(m_chatLog != null){
			// IbZ[WOɉ
			m_chatLog.logWrite("(SYSTEM--)", "ChatServlet stopped.");
			try {
				// Ot@Cɏo
				m_chatLog.close();
			}
			catch(SKException e){
				e.printStackTrace();
			}
		}
	}

	/** T[ubg̃C̏ */
	public void doMain(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException
	{
		try{
			response.setContentType("text/html; charset=" + m_strCharaCode);

			//String strAgent = request.getHeader("User-Agent");

			// p[^擾
			String strAction = request.getParameter(STR_ACTION);// R}h̎擾

			String strInputName = request.getParameter(STR_USERNAME);
			String strInputMessage = request.getParameter(STR_MESSAGE);

			// ΂炭̖nhQ҃Xg폜
			Calendar calCheck = ChatServlet.getNowCalendar();
			calCheck.add(Calendar.MINUTE, -1*m_nAutoQuit);	// m_nAutoQuitO̎
			Calendar calTmp;
			String strKey;
			for ( Enumeration e = m_handleTable.keys(); e.hasMoreElements(); ) {
				strKey = (String)(e.nextElement());
				HandleIdentifier handle = (HandleIdentifier)(m_handleTable.get(strKey));
				calTmp = handle.getCalendarUpdated();
				if ( calTmp.before(calCheck) ) {
					m_handleTable.remove(strKey);	// L[ƒl̍폜
				}
			}
			int nMemberNum = m_handleTable.size();

			// nhVK̂̂`FbN
			boolean bNewKey = false;
			if ( ChatServlet.isStrFair(strInputName) ) {
				// L[Ɋ܂܂Ă邩ǂ
				if ( !m_handleTable.containsKey(strInputName) ) {
					bNewKey = true;
				}
			}

			PrintWriter out = response.getWriter();

			StringBuffer strBuf = new StringBuffer();

			// --- ȉAw肳ꂽR}h(Action)ɂĕ\eς ----------

			// Action▼Ow肳ĂȂꍇ͓OƂ݂Ȃ
			if ( !(ChatServlet.isStrFair(strAction)) || !(ChatServlet.isStrFair(strInputName)) ) {
				strBuf.append( this.makeHeaderAndTitle(false) );	// wb_쐬
				strBuf.append( this.makeMemberNumStr(nMemberNum) );	// QҐl\

				// CookieT
				Cookie[] cookies = request.getCookies();
				if ( cookies != null ) {
					if ( cookies.length > 0 ) {
						for (int i = 0; i < cookies.length; i++) {
							Cookie cookie = cookies[i];
							if ( cookie.getName().equals("schat") ) {
								// ̃T[ubgpCookieI
								strInputName = getHandleStringFromCookie(cookie);
								break;
							}
						}
					}
				}

				// pO̓tH[쐬
				strBuf.append( this.makeEnterForm(ChatServlet.native2uni(strInputName)) );
			}
			// ގĂ
			else if ( strAction.equals(STR_ACT_QUIT) ) {
				if ( !bNewKey ) {
					m_handleTable.remove(strInputName);	// L[ƒl̍폜
				}

				strBuf.append( this.makeHeaderAndTitle(false) );	// wb_쐬
				nMemberNum = m_handleTable.size();
				strBuf.append( this.makeMemberNumStr(nMemberNum) );	// QҐl\

				// pO̓tH[쐬
				strBuf.append( this.makeEnterForm(ChatServlet.native2uni(strInputName)) );
			}
			// Ă
			else if ( strAction.equals(STR_ACT_ENTER) ) {
				if ( !bNewKey ) {	// nh̏d
					boolean bSameClient = false;

					// CookieT
					Cookie[] cookies = request.getCookies();
					if ( cookies.length > 0 ) {
						for (int i = 0; i < cookies.length; i++) {
							Cookie cookie = cookies[i];
							if ( cookie.getName().equals("schat") ) {
								// ̃T[ubgpCookieI

								String strCookieInputName = getHandleStringFromCookie(cookie);
								if ( strCookieInputName.equals(strInputName) ) {
									if ( m_handleTable.containsKey(strCookieInputName) ) {
										HandleIdentifier handle = (HandleIdentifier)(m_handleTable.get(strCookieInputName));
										if ( handle.getCalendarCreatedStr().equals( getCalendarStringFromCookie(cookie) ) ) {
											bSameClient = true;
										}
									}
								}
								break;
							}
						}
					}

					if ( bSameClient ) {
						HandleIdentifier handle = (HandleIdentifier)(m_handleTable.get(strInputName));
						handle.setCalendarUpdated(ChatServlet.getNowCalendar());
						m_handleTable.put(strInputName, handle);	// liHandleIdentifierj̍XV
						strBuf.append( this.makeHeaderAndTitle(true) );	// wb_쐬
						nMemberNum = m_handleTable.size();
						strBuf.append( this.makeMemberNumStr(nMemberNum) );	// QҐl\
						// ގ{^쐬
						strBuf.append( this.makeQuitForm("ގ", ChatServlet.native2uni(strInputName)) );
						// bZ[W̓tH[쐬
						strBuf.append( this.makeMessageForm(STR_ACT_TALKING, ChatServlet.native2uni(strInputName)) );
					}
					else {
						strBuf.append( this.makeHeaderAndTitle(false) );	// wb_쐬
						strBuf.append("@IɓO̎Q҂܂<BR><BR>");
						// pO̓tH[쐬
						strBuf.append( this.makeEnterForm(ChatServlet.native2uni(strInputName)) );
					}
				}
				else {

					// Cookie𔭍s
					Cookie cookie = new Cookie("schat", makeHandleAndTimeStringForCookie(strInputName));
					cookie.setMaxAge(60 * 60 * 24 * m_nCookieDays);	// for m_nCookieDays
					response.addCookie(cookie);

					HandleIdentifier handle = new HandleIdentifier(ChatServlet.getNowCalendar(), getCalendarStringFromCookie(cookie));
					m_handleTable.put(strInputName, handle);	// L[ƒliHandleIdentifierj̒ǉ

					strBuf.append( this.makeHeaderAndTitle(true) );	// wb_쐬
					nMemberNum = m_handleTable.size();
					strBuf.append( this.makeMemberNumStr(nMemberNum) );	// QҐl\

					// ގ{^쐬
					strBuf.append( this.makeQuitForm("ގ", ChatServlet.native2uni(strInputName)) );
					// bZ[W̓tH[쐬
					strBuf.append( this.makeMessageForm(STR_ACT_TALKING, ChatServlet.native2uni(strInputName)) );
				}
			}
			// Řb
			else if ( strAction.equals(STR_ACT_TALKING) ) {

				strBuf.append( this.makeHeaderAndTitle(true) );	// wb_쐬

				if ( !bNewKey ) {	// Q̏

					HandleIdentifier handle = (HandleIdentifier)(m_handleTable.get(strInputName));
					handle.setCalendarUpdated(ChatServlet.getNowCalendar());
					m_handleTable.put(strInputName, handle);	// liHandleIdentifierj̍XV
				}
				else {	// nhǗHashtableɖi΂炭uAT[oċNj
					strBuf.append("@IuvCłHHH<BR><BR>");

					// Cookie𔭍s
					Cookie cookie = new Cookie("schat", makeHandleAndTimeStringForCookie(strInputName));
					cookie.setMaxAge(60 * 60 * 24 * m_nCookieDays);	// for m_nCookieDays
					response.addCookie(cookie);
					HandleIdentifier handle = new HandleIdentifier(ChatServlet.getNowCalendar(), getCalendarStringFromCookie(cookie));
					m_handleTable.put(strInputName, handle);	// L[ƒliHandleIdentifierj̒ǉ
				}

				// ֎~[h`FbN
				String strWordCheck = null;
				if ( (strWordCheck = m_wordChecker.checkNGString(ChatServlet.native2uni(strInputName))) != null ) {
					strBuf.append("@IȂ̎w肵OɊ܂܂\"");
					strBuf.append(strWordCheck);
					strBuf.append("\"Ƃ͏߂܂<BR><BR>");
				}
				else if ( (strWordCheck = m_wordChecker.checkNGString(ChatServlet.native2uni(strInputMessage))) != null ) {
					strBuf.append("@IbZ[WɊ܂܂\"");
					strBuf.append(strWordCheck);
					strBuf.append("\"Ƃ͏߂܂<BR><BR>");
				}
				// f[^̕ۑ
				else if ( ChatServlet.isStrFair(strInputName) && ChatServlet.isStrFair(strInputMessage) ) {
					m_chatLog.logWrite(ChatServlet.native2uni(strInputName), ChatServlet.native2uni(strInputMessage));
				}

				nMemberNum = m_handleTable.size();
				strBuf.append( this.makeMemberNumStr(nMemberNum) );	// QҐl\

				// ގ{^쐬
				strBuf.append( this.makeQuitForm("ގ", ChatServlet.native2uni(strInputName)) );
				// bZ[W̓tH[쐬
				strBuf.append( this.makeMessageForm(STR_ACT_TALKING, ChatServlet.native2uni(strInputName)) );
			}
			// iɂ͗Ȃ͂j
			else {
				strBuf.append( this.makeHeaderAndTitle(false) );	// wb_쐬
				// ގ{^쐬
				strBuf.append( this.makeQuitForm("G[ۂ̂őގ", ChatServlet.native2uni(strInputName)) );
				strBuf.append("<BR><BR>Ǘ҂ɕ񍐂ĂB<BR>");
				ChatServlet.debugTrace("SChat : logic error!");
			}

			strBuf.append("<HR>");

			// VɃO\
			Vector vec = m_chatLog.getData();
			int nDoc = vec.size()/DEFS_ITEM_NUM;
			for ( int i = (nDoc - 1); i >= 0; i-- ) {	// ~
				strBuf.append( (String)(vec.get(DEFS_ITEM_NUM*i)) );
				strBuf.append("<BR>");
				strBuf.append( (String)(vec.get(DEFS_ITEM_NUM*i + 1)) );
				strBuf.append("&nbsp;F");
				strBuf.append( (String)(vec.get(DEFS_ITEM_NUM*i + 2)) );
				strBuf.append("<BR><HR>");
			}

			strBuf.append("<BR><BR><A HREF=\"http://www02.so-net.ne.jp/~kitaz/servlet/\" TARGET=\"_blank\">SChat1.1 is Free.</A><BR>");
			strBuf.append("</BODY></HTML>");

			out.println(strBuf.toString());
			return;
		}
		//catch(SKException ske){	// 󂱂ɂ͗܂(Ver1.1)
		//	ske.printStackTrace();
		//}
		catch(Exception e){
			e.printStackTrace();
		}
		PrintWriter out = response.getWriter();
		String strErrMSG = "SChat ERROR : 炩̃G[܂B<BR>Please report to kitade@za2.so-net.ne.jp<BR>";
		StringBuffer strBufErr = new StringBuffer();
		strBufErr.append("<HTML>");
		strBufErr.append("<HEAD><TITLE>");
		strBufErr.append( strErrMSG );
		strBufErr.append("</TITLE></HEAD>");
		strBufErr.append("<BODY>");
		strBufErr.append( strErrMSG );
		strBufErr.append("</BODY></HTML>");
		out.println( strBufErr.toString() );
	}

	/** HTTP Get NGXg̏ */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException
	{
		doMain(request, response);
	}
	/** HTTP Post NGXg̏ */
	public void doPost(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException
	{
		doMain(request, response);
	}


	// --- ChatServletp -------------------------------------------------------------

	/** wb_[ƃy[W㕔쐬
	 iĂꍇƂłȂꍇō킹tH[JXႤ̂łɐ؂oj */
	protected String makeHeaderAndTitle(boolean bLogin)
	{
		StringBuffer strBuf = new StringBuffer("<HTML>");
		strBuf.append("<HEAD><TITLE>");
		strBuf.append(m_strTitle);
		strBuf.append("</TITLE></HEAD>");
		strBuf.append("<META http-equiv=Content-Type content=text/html; charset=" + m_strCharaCode + ">\n");
		strBuf.append("<BODY TEXT=\"");
		strBuf.append(m_strTextColor);	// F
		strBuf.append("\" BGCOLOR=\"");
		strBuf.append(m_strBGColor);	// wiF
		strBuf.append("\" BACKGROUND=\"");
		strBuf.append(m_strBGImage);	// wi摜
		strBuf.append("\" LINK=\"");
		strBuf.append(m_strLinkColor);	// LINKF
		strBuf.append("\" VLINK=\"");
		strBuf.append(m_strVLinkColor);	// VLINKF
		strBuf.append("\" ALINK=\"");
		strBuf.append(m_strVLinkColor);	// ALINKFiVLINKFj
		if ( bLogin ) {
			strBuf.append("\" onLoad=document.");	// [hɃeLXg{bNXɃtH[JX킹
			strBuf.append(STR_ID_MESSFORM);	// bZ[W̓tH[
			strBuf.append(".");
			strBuf.append(STR_MESSAGE);
			strBuf.append(".focus(); >");
		}
		else {
			strBuf.append("\" onLoad=document.");	// [hɃeLXg{bNXɃtH[JX킹
			strBuf.append(STR_ID_NAMEFORM);	// O̓tH[
			strBuf.append(".");
			strBuf.append(STR_USERNAME);
			strBuf.append(".focus(); >");
		}
		strBuf.append("[<A HREF=\"");
		strBuf.append(m_strHomeURL);	// HOMEURL
		strBuf.append("\">HOME</A>]<BR>");
		strBuf.append("<CENTER><H3>");
		strBuf.append(m_strTitle);
		strBuf.append("</H3>");
		strBuf.append(m_strComment);
		strBuf.append("</CENTER><BR><BR>");
		return strBuf.toString();
	}

	/** QҐl\p̕쐬 */
	protected String makeMemberNumStr(int nMemberNum)
	{
		StringBuffer strBuf = new StringBuffer("݂̎QlF(");
		strBuf.append( String.valueOf(nMemberNum) );
		strBuf.append(")<BR><BR>");
		return strBuf.toString();
	}

	/** pO̓tH[쐬 */
	protected String makeEnterForm(String strName)
	{
		StringBuffer strBuf = new StringBuffer();
		strBuf.append( ChatServlet.makeFormFirst(STR_ID_NAMEFORM, m_strAlias) );
		strBuf.append( ChatServlet.makeHidden(STR_ACTION, STR_ACT_ENTER) );
		strBuf.append("OF");
		strBuf.append( ChatServlet.makeInputField(STR_USERNAME, 16, m_nMaxMessLength, strName) );
		strBuf.append("@");
		strBuf.append( ChatServlet.makeButtonString("", "button_in") );
		strBuf.append( ChatServlet.makeFormLast() );
		return strBuf.toString();
	}

	/** bZ[W̓tH[쐬 */
	protected String makeMessageForm(String strAction, String strName)
	{
		StringBuffer strBuf = new StringBuffer();
		strBuf.append( ChatServlet.makeFormFirst(STR_ID_MESSFORM, m_strAlias) );
		strBuf.append( ChatServlet.makeHidden(STR_ACTION, strAction) );	// b
		strBuf.append( ChatServlet.makeHidden(STR_USERNAME, strName) );
		strBuf.append("bZ[WF");
		strBuf.append( ChatServlet.makeInputField(STR_MESSAGE, 64, m_nMaxMessLength, null) );
		strBuf.append("@");
		strBuf.append( ChatServlet.makeButtonString(" or [h", "button_ok") );
		strBuf.append( ChatServlet.makeFormLast() );
		return strBuf.toString();
	}

	/** ގ{^쐬 */
	protected String makeQuitForm(String strBtnTitle, String strInputName)
	{
		StringBuffer strBuf = new StringBuffer();
		strBuf.append( ChatServlet.makeFormFirst(STR_ID_QUITFORM, m_strAlias) );
		strBuf.append( ChatServlet.makeHidden(STR_ACTION, STR_ACT_QUIT) );
		strBuf.append( ChatServlet.makeHidden(STR_USERNAME, strInputName) );
		strBuf.append( ChatServlet.makeButtonString(strBtnTitle, "button_out") );
		strBuf.append( ChatServlet.makeFormLast() );
		strBuf.append("<BR>");
		return strBuf.toString();
	}


	// --- HTML֘A ----------------------------------------------------------------

	/** hLgURL𓾂 */
	public static String makeURL(String strUri, String strAction)
	{
		StringBuffer strBufUrl = new StringBuffer(strUri);	// URI̓p[^ȃAhX
		strBufUrl.append("?");
		strBufUrl.append(STR_ACTION);
		strBufUrl.append("=");
		strBufUrl.append(strAction);
		return strBufUrl.toString();
	}

	/** <A HREF="strUrl">strText</A>̌`̕Ԃ */
	public static String makeAnchor(String strUrl, String strText)
	{
		StringBuffer strBuf = new StringBuffer("<A HREF=\"");
		strBuf.append(strUrl);
		strBuf.append("\">");
		strBuf.append(strText);
		strBuf.append("</A>");
		return strBuf.toString();
	}

	/** strUrl&key=datatĕԂ */
	public static String addParam(String strUrl, String strKey, String strData)
	{
		StringBuffer strBuf = new StringBuffer(strUrl);
		strBuf.append("&");
		strBuf.append(strKey);
		strBuf.append("=");
		strBuf.append(strData);
		return strBuf.toString();
	}

	/**
	 * ̓tH[F<INPUT TYPE="HIDDEN" NAME=... >
	 */
	public static String makeHidden( String strName, String strValue)
	{
		StringBuffer strBuf = new StringBuffer("<INPUT TYPE=\"HIDDEN\" NAME=\"");
			strBuf.append(strName);
			strBuf.append("\" VALUE=\"");
			strBuf.append(strValue);
			strBuf.append("\">\n");
		return strBuf.toString();
	}

	/**
	 * ̓tH[F<INPUT TYPE="TEXT" NAME =...
	 */
	public static String makeInputField(String strNameID, int nSize, int nMaxLength, String strVal)
	{
		StringBuffer strBuf = new StringBuffer("<INPUT TYPE=\"TEXT\" NAME=\"");
		strBuf.append(strNameID);
		strBuf.append("\" SIZE=\"");
		strBuf.append( String.valueOf(nSize) );
		strBuf.append("\" MAXLENGTH=\"");
		strBuf.append( String.valueOf(nMaxLength) );
		if ( strVal != null ) {
			strBuf.append("\" VALUE=\"");
			strBuf.append(strVal);
		}
		strBuf.append("\">\n");
		return strBuf.toString();
	}

	/**
	 * ̓tH[F<INPUT TYPE="SUBMIT" NAME =...
	 */
	public static String makeButtonString(String strTitle, String strParam)
	{
		StringBuffer strBuf = new StringBuffer("<INPUT TYPE=\"SUBMIT\" NAME=\"");
		strBuf.append(strParam);
		strBuf.append("\" VALUE=\"");
		strBuf.append(strTitle);
		strBuf.append("\"><BR>\n");
		return strBuf.toString();
	}

	/**
	 * ̓tH[F<FORM ... METHOD=...>
	 */
	public static String makeFormFirst(String strNameID, String strUrl)
	{
		StringBuffer strBuf = new StringBuffer();
		if ( DEFS_METHOD_POST ) {
			strBuf.append("<form METHOD=\"POST\" ACTION=\"");	// POST
		}
		else {
			strBuf.append("<form METHOD=\"GET\" ACTION=\"");	// GET
		}
		strBuf.append(strUrl);
		strBuf.append("\" NAME=\"");
		strBuf.append(strNameID);
		strBuf.append("\">\n");
		return strBuf.toString();
	}

	/**
	 * ̓tH[̏IF</FORM>
	 */
	public static String makeFormLast() {
		return "</FORM>";
	}


	// --- 낢 --------------------------------------------------------------------

	/** ɒg邩ǂׂ */
	public static boolean isStrFair(String strCheck)
	{
		if ( (strCheck == null) || strCheck.equals("") ) {
			return false;
		}
		return true;
	}

	/** CalendarŕԂ */
	public static Calendar getNowCalendar()
	{
		Calendar cal = new GregorianCalendar();
		cal.setTime(new Date(System.currentTimeMillis()));
		return cal;
	}

	/** R[hϊ */
	public static String native2uni( String strConv )
	{
		if ( !ChatServlet.isStrFair(strConv) ) {
			return strConv;
		}
		try{
			return new String( strConv.getBytes( "8859_1" ), m_strCharaCode );	// ϊ
		}
		catch( UnsupportedEncodingException ex ){
			System.err.println( ex.toString() );
			return strConv;	// ̂܂ܕԂ
		}
	}

	/** StringintɕϊisĂO𓊂Aw肳ꂽftHglԂj */
	public static int parseIntWithDefaultValue(String strConv, String strName, int nDefault)
	{
		if ( !(ChatServlet.isStrFair(strConv)) ) {
			ChatServlet.debugTrace(strName + " is null?");
			return nDefault;
		}
		else {
			try {
				return Integer.parseInt(strConv);
			}
			catch (NumberFormatException nfe) {
				ChatServlet.debugTrace("NumberFormatException : " + strName);
				return nDefault;
			}
		}
	}

	// --- fobOp ------------------------------------------------------------------

	/** fobOo */
	public static void debugTrace(String strOut)
	{
		if (DEFS_DEBUG) {
			System.out.println( strOut );
		}
	}

}
